/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * AddressSpace contains an array of IP address ranges that can be used by
 * subnets of the virtual network.
 *
 */
class AddressSpace {
  /**
   * Create a AddressSpace.
   * @property {array} [addressPrefixes] A list of address blocks reserved for
   * this virtual network in CIDR notation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AddressSpace
   *
   * @returns {object} metadata of AddressSpace
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AddressSpace',
      type: {
        name: 'Composite',
        className: 'AddressSpace',
        modelProperties: {
          addressPrefixes: {
            required: false,
            serializedName: 'addressPrefixes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AddressSpace;
