/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Application Gateway autoscale configuration.
 *
 */
class ApplicationGatewayAutoscaleConfiguration {
  /**
   * Create a ApplicationGatewayAutoscaleConfiguration.
   * @property {number} minCapacity Lower bound on number of Application
   * Gateway capacity
   * @property {number} [maxCapacity] Upper bound on number of Application
   * Gateway capacity
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayAutoscaleConfiguration
   *
   * @returns {object} metadata of ApplicationGatewayAutoscaleConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayAutoscaleConfiguration',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayAutoscaleConfiguration',
        modelProperties: {
          minCapacity: {
            required: true,
            serializedName: 'minCapacity',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          maxCapacity: {
            required: false,
            serializedName: 'maxCapacity',
            constraints: {
              InclusiveMinimum: 2
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayAutoscaleConfiguration;
