/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Customer error of an application gateway.
 *
 */
class ApplicationGatewayCustomError {
  /**
   * Create a ApplicationGatewayCustomError.
   * @property {string} [statusCode] Status code of the application gateway
   * customer error. Possible values include: 'HttpStatus403', 'HttpStatus502'
   * @property {string} [customErrorPageUrl] Error page URL of the application
   * gateway customer error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayCustomError
   *
   * @returns {object} metadata of ApplicationGatewayCustomError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayCustomError',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayCustomError',
        modelProperties: {
          statusCode: {
            required: false,
            serializedName: 'statusCode',
            type: {
              name: 'String'
            }
          },
          customErrorPageUrl: {
            required: false,
            serializedName: 'customErrorPageUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayCustomError;
