/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Allows to disable rules within a rule group or an entire rule group.
 *
 */
class ApplicationGatewayFirewallDisabledRuleGroup {
  /**
   * Create a ApplicationGatewayFirewallDisabledRuleGroup.
   * @property {string} ruleGroupName The name of the rule group that will be
   * disabled.
   * @property {array} [rules] The list of rules that will be disabled. If
   * null, all rules of the rule group will be disabled.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayFirewallDisabledRuleGroup
   *
   * @returns {object} metadata of ApplicationGatewayFirewallDisabledRuleGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayFirewallDisabledRuleGroup',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayFirewallDisabledRuleGroup',
        modelProperties: {
          ruleGroupName: {
            required: true,
            serializedName: 'ruleGroupName',
            type: {
              name: 'String'
            }
          },
          rules: {
            required: false,
            serializedName: 'rules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayFirewallDisabledRuleGroup;
