/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Allow to exclude some variable satisfy the condition for the WAF check
 *
 */
class ApplicationGatewayFirewallExclusion {
  /**
   * Create a ApplicationGatewayFirewallExclusion.
   * @property {string} matchVariable The variable to be excluded.
   * @property {string} selectorMatchOperator When matchVariable is a
   * collection, operate on the selector to specify which elements in the
   * collection this exclusion applies to.
   * @property {string} selector When matchVariable is a collection, operator
   * used to specify which elements in the collection this exclusion applies
   * to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayFirewallExclusion
   *
   * @returns {object} metadata of ApplicationGatewayFirewallExclusion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayFirewallExclusion',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayFirewallExclusion',
        modelProperties: {
          matchVariable: {
            required: true,
            serializedName: 'matchVariable',
            type: {
              name: 'String'
            }
          },
          selectorMatchOperator: {
            required: true,
            serializedName: 'selectorMatchOperator',
            type: {
              name: 'String'
            }
          },
          selector: {
            required: true,
            serializedName: 'selector',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayFirewallExclusion;
