/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A web application firewall rule group.
 *
 */
class ApplicationGatewayFirewallRuleGroup {
  /**
   * Create a ApplicationGatewayFirewallRuleGroup.
   * @property {string} ruleGroupName The name of the web application firewall
   * rule group.
   * @property {string} [description] The description of the web application
   * firewall rule group.
   * @property {array} rules The rules of the web application firewall rule
   * group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayFirewallRuleGroup
   *
   * @returns {object} metadata of ApplicationGatewayFirewallRuleGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayFirewallRuleGroup',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayFirewallRuleGroup',
        modelProperties: {
          ruleGroupName: {
            required: true,
            serializedName: 'ruleGroupName',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          rules: {
            required: true,
            serializedName: 'rules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationGatewayFirewallRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationGatewayFirewallRule'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayFirewallRuleGroup;
