/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Frontend IP configuration of an application gateway.
 *
 * @extends models['SubResource']
 */
class ApplicationGatewayFrontendIPConfiguration extends models['SubResource'] {
  /**
   * Create a ApplicationGatewayFrontendIPConfiguration.
   * @property {string} [privateIPAddress] PrivateIPAddress of the network
   * interface IP Configuration.
   * @property {string} [privateIPAllocationMethod] The private IP address
   * allocation method. Possible values include: 'Static', 'Dynamic'
   * @property {object} [subnet] Reference of the subnet resource.
   * @property {string} [subnet.id] Resource ID.
   * @property {object} [publicIPAddress] Reference of the PublicIP resource.
   * @property {string} [publicIPAddress.id] Resource ID.
   * @property {string} [provisioningState] Provisioning state of the public IP
   * resource. Possible values are: 'Updating', 'Deleting', and 'Failed'.
   * @property {string} [name] Name of the frontend IP configuration that is
   * unique within an Application Gateway.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   * @property {string} [type] Type of the resource.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationGatewayFrontendIPConfiguration
   *
   * @returns {object} metadata of ApplicationGatewayFrontendIPConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayFrontendIPConfiguration',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayFrontendIPConfiguration',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          privateIPAddress: {
            required: false,
            serializedName: 'properties.privateIPAddress',
            type: {
              name: 'String'
            }
          },
          privateIPAllocationMethod: {
            required: false,
            serializedName: 'properties.privateIPAllocationMethod',
            type: {
              name: 'String'
            }
          },
          subnet: {
            required: false,
            serializedName: 'properties.subnet',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          publicIPAddress: {
            required: false,
            serializedName: 'properties.publicIPAddress',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayFrontendIPConfiguration;
