/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IP configuration of an application gateway. Currently 1 public and 1 private
 * IP configuration is allowed.
 *
 * @extends models['SubResource']
 */
class ApplicationGatewayIPConfiguration extends models['SubResource'] {
  /**
   * Create a ApplicationGatewayIPConfiguration.
   * @property {object} [subnet] Reference of the subnet resource. A subnet
   * from where application gateway gets its private address.
   * @property {string} [subnet.id] Resource ID.
   * @property {string} [provisioningState] Provisioning state of the
   * application gateway subnet resource. Possible values are: 'Updating',
   * 'Deleting', and 'Failed'.
   * @property {string} [name] Name of the IP configuration that is unique
   * within an Application Gateway.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   * @property {string} [type] Type of the resource.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationGatewayIPConfiguration
   *
   * @returns {object} metadata of ApplicationGatewayIPConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayIPConfiguration',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayIPConfiguration',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          subnet: {
            required: false,
            serializedName: 'properties.subnet',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayIPConfiguration;
