/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SKU of an application gateway
 *
 */
class ApplicationGatewaySku {
  /**
   * Create a ApplicationGatewaySku.
   * @property {string} [name] Name of an application gateway SKU. Possible
   * values include: 'Standard_Small', 'Standard_Medium', 'Standard_Large',
   * 'WAF_Medium', 'WAF_Large', 'Standard_v2', 'WAF_v2'
   * @property {string} [tier] Tier of an application gateway. Possible values
   * include: 'Standard', 'WAF', 'Standard_v2', 'WAF_v2'
   * @property {number} [capacity] Capacity (instance count) of an application
   * gateway.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewaySku
   *
   * @returns {object} metadata of ApplicationGatewaySku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewaySku',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewaySku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewaySku;
