/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response for ListAuthorizations API service call retrieves all
 * authorizations that belongs to an ExpressRouteCircuit.
 */
class AuthorizationListResult extends Array {
  /**
   * Create a AuthorizationListResult.
   * @property {string} [nextLink] The URL to get the next set of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AuthorizationListResult
   *
   * @returns {object} metadata of AuthorizationListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AuthorizationListResult',
      type: {
        name: 'Composite',
        className: 'AuthorizationListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ExpressRouteCircuitAuthorizationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ExpressRouteCircuitAuthorization'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AuthorizationListResult;
