/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Constraints that determine the list of available Internet service providers.
 *
 */
class AvailableProvidersListParameters {
  /**
   * Create a AvailableProvidersListParameters.
   * @property {array} [azureLocations] A list of Azure regions.
   * @property {string} [country] The country for available providers list.
   * @property {string} [state] The state for available providers list.
   * @property {string} [city] The city or town for available providers list.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AvailableProvidersListParameters
   *
   * @returns {object} metadata of AvailableProvidersListParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AvailableProvidersListParameters',
      type: {
        name: 'Composite',
        className: 'AvailableProvidersListParameters',
        modelProperties: {
          azureLocations: {
            required: false,
            serializedName: 'azureLocations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          country: {
            required: false,
            serializedName: 'country',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          city: {
            required: false,
            serializedName: 'city',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AvailableProvidersListParameters;
