/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response body contains the status of the specified asynchronous
 * operation, indicating whether it has succeeded, is in progress, or has
 * failed. Note that this status is distinct from the HTTP status code returned
 * for the Get Operation Status operation itself. If the asynchronous operation
 * succeeded, the response body includes the HTTP status code for the
 * successful request. If the asynchronous operation failed, the response body
 * includes the HTTP status code for the failed request and error information
 * regarding the failure.
 *
 */
class AzureAsyncOperationResult {
  /**
   * Create a AzureAsyncOperationResult.
   * @property {string} [status] Status of the Azure async operation. Possible
   * values are: 'InProgress', 'Succeeded', and 'Failed'. Possible values
   * include: 'InProgress', 'Succeeded', 'Failed'
   * @property {object} [error] Details of the error occurred during specified
   * asynchronous operation.
   * @property {string} [error.code] Error code.
   * @property {string} [error.message] Error message.
   * @property {string} [error.target] Error target.
   * @property {array} [error.details] Error details.
   * @property {string} [error.innerError] Inner error message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureAsyncOperationResult
   *
   * @returns {object} metadata of AzureAsyncOperationResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureAsyncOperationResult',
      type: {
        name: 'Composite',
        className: 'AzureAsyncOperationResult',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorModel'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureAsyncOperationResult;
