/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IP configuration of an Azure Firewall.
 *
 * @extends models['SubResource']
 */
class AzureFirewallIPConfiguration extends models['SubResource'] {
  /**
   * Create a AzureFirewallIPConfiguration.
   * @property {string} [privateIPAddress] The Firewall Internal Load Balancer
   * IP to be used as the next hop in User Defined Routes.
   * @property {object} [subnet] Reference of the subnet resource. This
   * resource must be named 'AzureFirewallSubnet'.
   * @property {string} [subnet.id] Resource ID.
   * @property {object} [publicIPAddress] Reference of the PublicIP resource.
   * This field is a mandatory input if subnet is not null.
   * @property {string} [publicIPAddress.id] Resource ID.
   * @property {string} [provisioningState] The provisioning state of the
   * resource. Possible values include: 'Succeeded', 'Updating', 'Deleting',
   * 'Failed'
   * @property {string} [name] Name of the resource that is unique within a
   * resource group. This name can be used to access the resource.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureFirewallIPConfiguration
   *
   * @returns {object} metadata of AzureFirewallIPConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureFirewallIPConfiguration',
      type: {
        name: 'Composite',
        className: 'AzureFirewallIPConfiguration',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          privateIPAddress: {
            required: false,
            readOnly: true,
            serializedName: 'properties.privateIPAddress',
            type: {
              name: 'String'
            }
          },
          subnet: {
            required: false,
            serializedName: 'properties.subnet',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          publicIPAddress: {
            required: false,
            serializedName: 'properties.publicIPAddress',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFirewallIPConfiguration;
