/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the network rule.
 *
 */
class AzureFirewallNetworkRule {
  /**
   * Create a AzureFirewallNetworkRule.
   * @property {string} [name] Name of the network rule.
   * @property {string} [description] Description of the rule.
   * @property {array} [protocols] Array of AzureFirewallNetworkRuleProtocols.
   * @property {array} [sourceAddresses] List of source IP addresses for this
   * rule.
   * @property {array} [destinationAddresses] List of destination IP addresses.
   * @property {array} [destinationPorts] List of destination ports.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureFirewallNetworkRule
   *
   * @returns {object} metadata of AzureFirewallNetworkRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureFirewallNetworkRule',
      type: {
        name: 'Composite',
        className: 'AzureFirewallNetworkRule',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          protocols: {
            required: false,
            serializedName: 'protocols',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureFirewallNetworkRuleProtocolElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sourceAddresses: {
            required: false,
            serializedName: 'sourceAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          destinationAddresses: {
            required: false,
            serializedName: 'destinationAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          destinationPorts: {
            required: false,
            serializedName: 'destinationPorts',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFirewallNetworkRule;
