/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure reachability report details.
 *
 */
class AzureReachabilityReport {
  /**
   * Create a AzureReachabilityReport.
   * @property {string} aggregationLevel The aggregation level of Azure
   * reachability report. Can be Country, State or City.
   * @property {object} providerLocation Parameters that define a geographic
   * location.
   * @property {string} [providerLocation.country] The name of the country.
   * @property {string} [providerLocation.state] The name of the state.
   * @property {string} [providerLocation.city] The name of the city or town.
   * @property {array} reachabilityReport List of Azure reachability report
   * items.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureReachabilityReport
   *
   * @returns {object} metadata of AzureReachabilityReport
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureReachabilityReport',
      type: {
        name: 'Composite',
        className: 'AzureReachabilityReport',
        modelProperties: {
          aggregationLevel: {
            required: true,
            serializedName: 'aggregationLevel',
            type: {
              name: 'String'
            }
          },
          providerLocation: {
            required: true,
            serializedName: 'providerLocation',
            type: {
              name: 'Composite',
              className: 'AzureReachabilityReportLocation'
            }
          },
          reachabilityReport: {
            required: true,
            serializedName: 'reachabilityReport',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureReachabilityReportItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureReachabilityReportItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureReachabilityReport;
