/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure reachability report details for a given provider location.
 *
 */
class AzureReachabilityReportItem {
  /**
   * Create a AzureReachabilityReportItem.
   * @property {string} [provider] The Internet service provider.
   * @property {string} [azureLocation] The Azure region.
   * @property {array} [latencies] List of latency details for each of the time
   * series.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureReachabilityReportItem
   *
   * @returns {object} metadata of AzureReachabilityReportItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureReachabilityReportItem',
      type: {
        name: 'Composite',
        className: 'AzureReachabilityReportItem',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          azureLocation: {
            required: false,
            serializedName: 'azureLocation',
            type: {
              name: 'String'
            }
          },
          latencies: {
            required: false,
            serializedName: 'latencies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureReachabilityReportLatencyInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureReachabilityReportLatencyInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureReachabilityReportItem;
