/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details on latency for a time series.
 *
 */
class AzureReachabilityReportLatencyInfo {
  /**
   * Create a AzureReachabilityReportLatencyInfo.
   * @property {date} [timeStamp] The time stamp.
   * @property {number} [score] The relative latency score between 1 and 100,
   * higher values indicating a faster connection.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureReachabilityReportLatencyInfo
   *
   * @returns {object} metadata of AzureReachabilityReportLatencyInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureReachabilityReportLatencyInfo',
      type: {
        name: 'Composite',
        className: 'AzureReachabilityReportLatencyInfo',
        modelProperties: {
          timeStamp: {
            required: false,
            serializedName: 'timeStamp',
            type: {
              name: 'DateTime'
            }
          },
          score: {
            required: false,
            serializedName: 'score',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureReachabilityReportLatencyInfo;
