/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Geographic and time constraints for Azure reachability report.
 *
 */
class AzureReachabilityReportParameters {
  /**
   * Create a AzureReachabilityReportParameters.
   * @property {object} providerLocation Parameters that define a geographic
   * location.
   * @property {string} [providerLocation.country] The name of the country.
   * @property {string} [providerLocation.state] The name of the state.
   * @property {string} [providerLocation.city] The name of the city or town.
   * @property {array} [providers] List of Internet service providers.
   * @property {array} [azureLocations] Optional Azure regions to scope the
   * query to.
   * @property {date} startTime The start time for the Azure reachability
   * report.
   * @property {date} endTime The end time for the Azure reachability report.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureReachabilityReportParameters
   *
   * @returns {object} metadata of AzureReachabilityReportParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureReachabilityReportParameters',
      type: {
        name: 'Composite',
        className: 'AzureReachabilityReportParameters',
        modelProperties: {
          providerLocation: {
            required: true,
            serializedName: 'providerLocation',
            type: {
              name: 'Composite',
              className: 'AzureReachabilityReportLocation'
            }
          },
          providers: {
            required: false,
            serializedName: 'providers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          azureLocations: {
            required: false,
            serializedName: 'azureLocations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureReachabilityReportParameters;
