/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Service Community Properties.
 *
 * @extends models['Resource']
 */
class BgpServiceCommunity extends models['Resource'] {
  /**
   * Create a BgpServiceCommunity.
   * @property {string} [serviceName] The name of the bgp community. e.g.
   * Skype.
   * @property {array} [bgpCommunities] Get a list of bgp communities.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BgpServiceCommunity
   *
   * @returns {object} metadata of BgpServiceCommunity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BgpServiceCommunity',
      type: {
        name: 'Composite',
        className: 'BgpServiceCommunity',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          serviceName: {
            required: false,
            serializedName: 'properties.serviceName',
            type: {
              name: 'String'
            }
          },
          bgpCommunities: {
            required: false,
            serializedName: 'properties.bgpCommunities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BGPCommunityElementType',
                  type: {
                    name: 'Composite',
                    className: 'BGPCommunity'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = BgpServiceCommunity;
