/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * BGP settings details
 *
 */
class BgpSettings {
  /**
   * Create a BgpSettings.
   * @property {number} [asn] The BGP speaker's ASN.
   * @property {string} [bgpPeeringAddress] The BGP peering address and BGP
   * identifier of this BGP speaker.
   * @property {number} [peerWeight] The weight added to routes learned from
   * this BGP speaker.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BgpSettings
   *
   * @returns {object} metadata of BgpSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BgpSettings',
      type: {
        name: 'Composite',
        className: 'BgpSettings',
        modelProperties: {
          asn: {
            required: false,
            serializedName: 'asn',
            type: {
              name: 'Number'
            }
          },
          bgpPeeringAddress: {
            required: false,
            serializedName: 'bgpPeeringAddress',
            type: {
              name: 'String'
            }
          },
          peerWeight: {
            required: false,
            serializedName: 'peerWeight',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = BgpSettings;
