/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the destination of connection monitor.
 *
 */
class ConnectionMonitorDestination {
  /**
   * Create a ConnectionMonitorDestination.
   * @property {string} [resourceId] The ID of the resource used as the
   * destination by connection monitor.
   * @property {string} [address] Address of the connection monitor destination
   * (IP or domain name).
   * @property {number} [port] The destination port used by connection monitor.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectionMonitorDestination
   *
   * @returns {object} metadata of ConnectionMonitorDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectionMonitorDestination',
      type: {
        name: 'Composite',
        className: 'ConnectionMonitorDestination',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          address: {
            required: false,
            serializedName: 'address',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectionMonitorDestination;
