/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of connection states snapshots.
 *
 */
class ConnectionMonitorQueryResult {
  /**
   * Create a ConnectionMonitorQueryResult.
   * @property {string} [sourceStatus] Status of connection monitor source.
   * Possible values include: 'Unknown', 'Active', 'Inactive'
   * @property {array} [states] Information about connection states.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectionMonitorQueryResult
   *
   * @returns {object} metadata of ConnectionMonitorQueryResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectionMonitorQueryResult',
      type: {
        name: 'Composite',
        className: 'ConnectionMonitorQueryResult',
        modelProperties: {
          sourceStatus: {
            required: false,
            serializedName: 'sourceStatus',
            type: {
              name: 'String'
            }
          },
          states: {
            required: false,
            serializedName: 'states',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ConnectionStateSnapshotElementType',
                  type: {
                    name: 'Composite',
                    className: 'ConnectionStateSnapshot'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectionMonitorQueryResult;
