/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Response for GetConnectionSharedKey API service call
 *
 * @extends models['SubResource']
 */
class ConnectionSharedKey extends models['SubResource'] {
  /**
   * Create a ConnectionSharedKey.
   * @property {string} value The virtual network connection shared key value.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ConnectionSharedKey
   *
   * @returns {object} metadata of ConnectionSharedKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectionSharedKey',
      type: {
        name: 'Composite',
        className: 'ConnectionSharedKey',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectionSharedKey;
