/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters that define destination of connection.
 *
 */
class ConnectivityDestination {
  /**
   * Create a ConnectivityDestination.
   * @property {string} [resourceId] The ID of the resource to which a
   * connection attempt will be made.
   * @property {string} [address] The IP address or URI the resource to which a
   * connection attempt will be made.
   * @property {number} [port] Port on which check connectivity will be
   * performed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectivityDestination
   *
   * @returns {object} metadata of ConnectivityDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectivityDestination',
      type: {
        name: 'Composite',
        className: 'ConnectivityDestination',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          address: {
            required: false,
            serializedName: 'address',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectivityDestination;
