/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The ip configuration for a container network interface.
 *
 */
class ContainerNetworkInterfaceIpConfiguration {
  /**
   * Create a ContainerNetworkInterfaceIpConfiguration.
   * @property {string} [provisioningState] The provisioning state of the
   * resource.
   * @property {string} [name] The name of the resource. This name can be used
   * to access the resource.
   * @property {string} [type] Sub Resource type.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerNetworkInterfaceIpConfiguration
   *
   * @returns {object} metadata of ContainerNetworkInterfaceIpConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerNetworkInterfaceIpConfiguration',
      type: {
        name: 'Composite',
        className: 'ContainerNetworkInterfaceIpConfiguration',
        modelProperties: {
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerNetworkInterfaceIpConfiguration;
