/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A DDoS custom policy in a resource group.
 *
 * @extends models['Resource']
 */
class DdosCustomPolicy extends models['Resource'] {
  /**
   * Create a DdosCustomPolicy.
   * @property {string} [resourceGuid] The resource GUID property of the DDoS
   * custom policy resource. It uniquely identifies the resource, even if the
   * user changes its name or migrate the resource across subscriptions or
   * resource groups.
   * @property {string} [provisioningState] The provisioning state of the DDoS
   * custom policy resource. Possible values are: 'Succeeded', 'Updating',
   * 'Deleting', and 'Failed'.
   * @property {array} [publicIPAddresses] The list of public IPs associated
   * with the DDoS custom policy resource. This list is read-only.
   * @property {array} [protocolCustomSettings] The protocol-specific DDoS
   * policy customization parameters.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DdosCustomPolicy
   *
   * @returns {object} metadata of DdosCustomPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DdosCustomPolicy',
      type: {
        name: 'Composite',
        className: 'DdosCustomPolicy',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          resourceGuid: {
            required: false,
            readOnly: true,
            serializedName: 'properties.resourceGuid',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          publicIPAddresses: {
            required: false,
            readOnly: true,
            serializedName: 'properties.publicIPAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SubResourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'SubResource'
                  }
              }
            }
          },
          protocolCustomSettings: {
            required: false,
            serializedName: 'properties.protocolCustomSettings',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ProtocolCustomSettingsFormatElementType',
                  type: {
                    name: 'Composite',
                    className: 'ProtocolCustomSettingsFormat'
                  }
              }
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DdosCustomPolicy;
