/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains the DDoS protection settings of the public IP.
 *
 */
class DdosSettings {
  /**
   * Create a DdosSettings.
   * @property {object} [ddosCustomPolicy] The DDoS custom policy associated
   * with the public IP.
   * @property {string} [ddosCustomPolicy.id] Resource ID.
   * @property {string} [protectionCoverage] The DDoS protection policy
   * customizability of the public IP. Only standard coverage will have the
   * ability to be customized. Possible values include: 'Basic', 'Standard'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DdosSettings
   *
   * @returns {object} metadata of DdosSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DdosSettings',
      type: {
        name: 'Composite',
        className: 'DdosSettings',
        modelProperties: {
          ddosCustomPolicy: {
            required: false,
            serializedName: 'ddosCustomPolicy',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          protectionCoverage: {
            required: false,
            serializedName: 'protectionCoverage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DdosSettings;
