/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of properties of the device.
 *
 */
class DeviceProperties {
  /**
   * Create a DeviceProperties.
   * @property {string} [deviceVendor] Name of the device Vendor.
   * @property {string} [deviceModel] Model of the device.
   * @property {number} [linkSpeedInMbps] Link speed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceProperties
   *
   * @returns {object} metadata of DeviceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceProperties',
      type: {
        name: 'Composite',
        className: 'DeviceProperties',
        modelProperties: {
          deviceVendor: {
            required: false,
            serializedName: 'deviceVendor',
            type: {
              name: 'String'
            }
          },
          deviceModel: {
            required: false,
            serializedName: 'deviceModel',
            type: {
              name: 'String'
            }
          },
          linkSpeedInMbps: {
            required: false,
            serializedName: 'linkSpeedInMbps',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceProperties;
