/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * DhcpOptions contains an array of DNS servers available to VMs deployed in
 * the virtual network. Standard DHCP option for a subnet overrides VNET DHCP
 * options.
 *
 */
class DhcpOptions {
  /**
   * Create a DhcpOptions.
   * @property {array} [dnsServers] The list of DNS servers IP addresses.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DhcpOptions
   *
   * @returns {object} metadata of DhcpOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DhcpOptions',
      type: {
        name: 'Composite',
        className: 'DhcpOptions',
        modelProperties: {
          dnsServers: {
            required: false,
            serializedName: 'dnsServers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DhcpOptions;
