/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Endpoint service.
 *
 * @extends models['SubResource']
 */
class EndpointServiceResult extends models['SubResource'] {
  /**
   * Create a EndpointServiceResult.
   * @property {string} [name] Name of the endpoint service.
   * @property {string} [type] Type of the endpoint service.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EndpointServiceResult
   *
   * @returns {object} metadata of EndpointServiceResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EndpointServiceResult',
      type: {
        name: 'Composite',
        className: 'EndpointServiceResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EndpointServiceResult;
