/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The ARP table associated with the ExpressRouteCircuit.
 *
 */
class ExpressRouteCircuitArpTable {
  /**
   * Create a ExpressRouteCircuitArpTable.
   * @property {number} [age] Entry age in minutes
   * @property {string} [interfaceProperty] Interface address
   * @property {string} [ipAddress] The IP address.
   * @property {string} [macAddress] The MAC address.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRouteCircuitArpTable
   *
   * @returns {object} metadata of ExpressRouteCircuitArpTable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteCircuitArpTable',
      type: {
        name: 'Composite',
        className: 'ExpressRouteCircuitArpTable',
        modelProperties: {
          age: {
            required: false,
            serializedName: 'age',
            type: {
              name: 'Number'
            }
          },
          interfaceProperty: {
            required: false,
            serializedName: 'interface',
            type: {
              name: 'String'
            }
          },
          ipAddress: {
            required: false,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          macAddress: {
            required: false,
            serializedName: 'macAddress',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteCircuitArpTable;
