/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Authorization in an ExpressRouteCircuit resource.
 *
 * @extends models['SubResource']
 */
class ExpressRouteCircuitAuthorization extends models['SubResource'] {
  /**
   * Create a ExpressRouteCircuitAuthorization.
   * @property {string} [authorizationKey] The authorization key.
   * @property {string} [authorizationUseStatus] AuthorizationUseStatus.
   * Possible values are: 'Available' and 'InUse'. Possible values include:
   * 'Available', 'InUse'
   * @property {string} [provisioningState] Gets the provisioning state of the
   * public IP resource. Possible values are: 'Updating', 'Deleting', and
   * 'Failed'.
   * @property {string} [name] Gets name of the resource that is unique within
   * a resource group. This name can be used to access the resource.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExpressRouteCircuitAuthorization
   *
   * @returns {object} metadata of ExpressRouteCircuitAuthorization
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteCircuitAuthorization',
      type: {
        name: 'Composite',
        className: 'ExpressRouteCircuitAuthorization',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          authorizationKey: {
            required: false,
            serializedName: 'properties.authorizationKey',
            type: {
              name: 'String'
            }
          },
          authorizationUseStatus: {
            required: false,
            serializedName: 'properties.authorizationUseStatus',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteCircuitAuthorization;
