/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The routes table associated with the ExpressRouteCircuit
 *
 */
class ExpressRouteCircuitRoutesTable {
  /**
   * Create a ExpressRouteCircuitRoutesTable.
   * @property {string} [network] IP address of a network entity
   * @property {string} [nextHop] NextHop address
   * @property {string} [locPrf] Local preference value as set with the set
   * local-preference route-map configuration command
   * @property {number} [weight] Route Weight.
   * @property {string} [path] Autonomous system paths to the destination
   * network.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRouteCircuitRoutesTable
   *
   * @returns {object} metadata of ExpressRouteCircuitRoutesTable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteCircuitRoutesTable',
      type: {
        name: 'Composite',
        className: 'ExpressRouteCircuitRoutesTable',
        modelProperties: {
          network: {
            required: false,
            serializedName: 'network',
            type: {
              name: 'String'
            }
          },
          nextHop: {
            required: false,
            serializedName: 'nextHop',
            type: {
              name: 'String'
            }
          },
          locPrf: {
            required: false,
            serializedName: 'locPrf',
            type: {
              name: 'String'
            }
          },
          weight: {
            required: false,
            serializedName: 'weight',
            type: {
              name: 'Number'
            }
          },
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteCircuitRoutesTable;
