/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains ServiceProviderProperties in an ExpressRouteCircuit.
 *
 */
class ExpressRouteCircuitServiceProviderProperties {
  /**
   * Create a ExpressRouteCircuitServiceProviderProperties.
   * @property {string} [serviceProviderName] The serviceProviderName.
   * @property {string} [peeringLocation] The peering location.
   * @property {number} [bandwidthInMbps] The BandwidthInMbps.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRouteCircuitServiceProviderProperties
   *
   * @returns {object} metadata of ExpressRouteCircuitServiceProviderProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteCircuitServiceProviderProperties',
      type: {
        name: 'Composite',
        className: 'ExpressRouteCircuitServiceProviderProperties',
        modelProperties: {
          serviceProviderName: {
            required: false,
            serializedName: 'serviceProviderName',
            type: {
              name: 'String'
            }
          },
          peeringLocation: {
            required: false,
            serializedName: 'peeringLocation',
            type: {
              name: 'String'
            }
          },
          bandwidthInMbps: {
            required: false,
            serializedName: 'bandwidthInMbps',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteCircuitServiceProviderProperties;
