/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains SKU in an ExpressRouteCircuit.
 *
 */
class ExpressRouteCircuitSku {
  /**
   * Create a ExpressRouteCircuitSku.
   * @property {string} [name] The name of the SKU.
   * @property {string} [tier] The tier of the SKU. Possible values are
   * 'Standard', 'Premium' or 'Local'. Possible values include: 'Standard',
   * 'Premium', 'Basic', 'Local'
   * @property {string} [family] The family of the SKU. Possible values are:
   * 'UnlimitedData' and 'MeteredData'. Possible values include:
   * 'UnlimitedData', 'MeteredData'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRouteCircuitSku
   *
   * @returns {object} metadata of ExpressRouteCircuitSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteCircuitSku',
      type: {
        name: 'Composite',
        className: 'ExpressRouteCircuitSku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          family: {
            required: false,
            serializedName: 'family',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteCircuitSku;
