/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains stats associated with the peering.
 *
 */
class ExpressRouteCircuitStats {
  /**
   * Create a ExpressRouteCircuitStats.
   * @property {number} [primarybytesIn] Gets BytesIn of the peering.
   * @property {number} [primarybytesOut] Gets BytesOut of the peering.
   * @property {number} [secondarybytesIn] Gets BytesIn of the peering.
   * @property {number} [secondarybytesOut] Gets BytesOut of the peering.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRouteCircuitStats
   *
   * @returns {object} metadata of ExpressRouteCircuitStats
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteCircuitStats',
      type: {
        name: 'Composite',
        className: 'ExpressRouteCircuitStats',
        modelProperties: {
          primarybytesIn: {
            required: false,
            serializedName: 'primarybytesIn',
            type: {
              name: 'Number'
            }
          },
          primarybytesOut: {
            required: false,
            serializedName: 'primarybytesOut',
            type: {
              name: 'Number'
            }
          },
          secondarybytesIn: {
            required: false,
            serializedName: 'secondarybytesIn',
            type: {
              name: 'Number'
            }
          },
          secondarybytesOut: {
            required: false,
            serializedName: 'secondarybytesOut',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteCircuitStats;
