/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Configuration for auto scaling.
 *
 */
class ExpressRouteGatewayPropertiesAutoScaleConfiguration {
  /**
   * Create a ExpressRouteGatewayPropertiesAutoScaleConfiguration.
   * @property {object} [bounds] Minimum and maximum number of scale units to
   * deploy.
   * @property {number} [bounds.min] Minimum number of scale units deployed for
   * ExpressRoute gateway.
   * @property {number} [bounds.max] Maximum number of scale units deployed for
   * ExpressRoute gateway.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRouteGatewayPropertiesAutoScaleConfiguration
   *
   * @returns {object} metadata of ExpressRouteGatewayPropertiesAutoScaleConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRouteGatewayProperties_autoScaleConfiguration',
      type: {
        name: 'Composite',
        className: 'ExpressRouteGatewayPropertiesAutoScaleConfiguration',
        modelProperties: {
          bounds: {
            required: false,
            serializedName: 'bounds',
            type: {
              name: 'Composite',
              className: 'ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRouteGatewayPropertiesAutoScaleConfiguration;
