/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary ExpressRoutePorts Location Bandwidths
  *
 * Real-time inventory of available ExpressRoute port bandwidths.
 *
 */
class ExpressRoutePortsLocationBandwidths {
  /**
   * Create a ExpressRoutePortsLocationBandwidths.
   * @property {string} [offerName] Bandwidth descriptive name
   * @property {number} [valueInGbps] Bandwidth value in Gbps
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExpressRoutePortsLocationBandwidths
   *
   * @returns {object} metadata of ExpressRoutePortsLocationBandwidths
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressRoutePortsLocationBandwidths',
      type: {
        name: 'Composite',
        className: 'ExpressRoutePortsLocationBandwidths',
        modelProperties: {
          offerName: {
            required: false,
            readOnly: true,
            serializedName: 'offerName',
            type: {
              name: 'String'
            }
          },
          valueInGbps: {
            required: false,
            readOnly: true,
            serializedName: 'valueInGbps',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressRoutePortsLocationBandwidths;
