/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters that define the flow log format.
 *
 */
class FlowLogFormatParameters {
  /**
   * Create a FlowLogFormatParameters.
   * @property {string} [type] The file type of flow log. Possible values
   * include: 'JSON'
   * @property {number} [version] The version (revision) of the flow log.
   * Default value: 0 .
   */
  constructor() {
  }

  /**
   * Defines the metadata of FlowLogFormatParameters
   *
   * @returns {object} metadata of FlowLogFormatParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FlowLogFormatParameters',
      type: {
        name: 'Composite',
        className: 'FlowLogFormatParameters',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            defaultValue: 0,
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = FlowLogFormatParameters;
