/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of Vpn-Sites
 *
 */
class GetVpnSitesConfigurationRequest {
  /**
   * Create a GetVpnSitesConfigurationRequest.
   * @property {array} [vpnSites] List of resource-ids of the vpn-sites for
   * which config is to be downloaded.
   * @property {string} outputBlobSasUrl The sas-url to download the
   * configurations for vpn-sites
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetVpnSitesConfigurationRequest
   *
   * @returns {object} metadata of GetVpnSitesConfigurationRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetVpnSitesConfigurationRequest',
      type: {
        name: 'Composite',
        className: 'GetVpnSitesConfigurationRequest',
        modelProperties: {
          vpnSites: {
            required: false,
            serializedName: 'vpnSites',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          outputBlobSasUrl: {
            required: true,
            serializedName: 'outputBlobSasUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GetVpnSitesConfigurationRequest;
