/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response for CheckIPAddressAvailability API service call
 *
 */
class IPAddressAvailabilityResult {
  /**
   * Create a IPAddressAvailabilityResult.
   * @property {boolean} [available] Private IP address availability.
   * @property {array} [availableIPAddresses] Contains other available private
   * IP addresses if the asked for address is taken.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IPAddressAvailabilityResult
   *
   * @returns {object} metadata of IPAddressAvailabilityResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IPAddressAvailabilityResult',
      type: {
        name: 'Composite',
        className: 'IPAddressAvailabilityResult',
        modelProperties: {
          available: {
            required: false,
            serializedName: 'available',
            type: {
              name: 'Boolean'
            }
          },
          availableIPAddresses: {
            required: false,
            serializedName: 'availableIPAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IPAddressAvailabilityResult;
