/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ApplicationGatewayProbeHealthResponseMatch = require('./applicationGatewayProbeHealthResponseMatch');
exports.ApplicationGatewayOnDemandProbe = require('./applicationGatewayOnDemandProbe');
exports.SubResource = require('./subResource');
exports.NetworkInterfaceTapConfiguration = require('./networkInterfaceTapConfiguration');
exports.Resource = require('./resource');
exports.ApplicationSecurityGroup = require('./applicationSecurityGroup');
exports.SecurityRule = require('./securityRule');
exports.EndpointService = require('./endpointService');
exports.InterfaceEndpoint = require('./interfaceEndpoint');
exports.NetworkInterfaceDnsSettings = require('./networkInterfaceDnsSettings');
exports.NetworkInterface = require('./networkInterface');
exports.NetworkSecurityGroup = require('./networkSecurityGroup');
exports.Route = require('./route');
exports.RouteTable = require('./routeTable');
exports.ServiceEndpointPropertiesFormat = require('./serviceEndpointPropertiesFormat');
exports.ServiceEndpointPolicyDefinition = require('./serviceEndpointPolicyDefinition');
exports.ServiceEndpointPolicy = require('./serviceEndpointPolicy');
exports.PublicIPAddressSku = require('./publicIPAddressSku');
exports.PublicIPAddressDnsSettings = require('./publicIPAddressDnsSettings');
exports.DdosSettings = require('./ddosSettings');
exports.IpTag = require('./ipTag');
exports.PublicIPAddress = require('./publicIPAddress');
exports.IPConfiguration = require('./iPConfiguration');
exports.IPConfigurationProfile = require('./iPConfigurationProfile');
exports.ResourceNavigationLink = require('./resourceNavigationLink');
exports.ServiceAssociationLink = require('./serviceAssociationLink');
exports.Delegation = require('./delegation');
exports.Subnet = require('./subnet');
exports.FrontendIPConfiguration = require('./frontendIPConfiguration');
exports.VirtualNetworkTap = require('./virtualNetworkTap');
exports.BackendAddressPool = require('./backendAddressPool');
exports.InboundNatRule = require('./inboundNatRule');
exports.NetworkInterfaceIPConfiguration = require('./networkInterfaceIPConfiguration');
exports.ApplicationGatewayBackendAddress = require('./applicationGatewayBackendAddress');
exports.ApplicationGatewayBackendAddressPool = require('./applicationGatewayBackendAddressPool');
exports.ApplicationGatewayConnectionDraining = require('./applicationGatewayConnectionDraining');
exports.ApplicationGatewayBackendHttpSettings = require('./applicationGatewayBackendHttpSettings');
exports.ApplicationGatewayBackendHealthServer = require('./applicationGatewayBackendHealthServer');
exports.ApplicationGatewayBackendHealthHttpSettings = require('./applicationGatewayBackendHealthHttpSettings');
exports.ApplicationGatewayBackendHealthOnDemand = require('./applicationGatewayBackendHealthOnDemand');
exports.ApplicationGatewayBackendHealthPool = require('./applicationGatewayBackendHealthPool');
exports.ApplicationGatewayBackendHealth = require('./applicationGatewayBackendHealth');
exports.ApplicationGatewaySku = require('./applicationGatewaySku');
exports.ApplicationGatewaySslPolicy = require('./applicationGatewaySslPolicy');
exports.ApplicationGatewayIPConfiguration = require('./applicationGatewayIPConfiguration');
exports.ApplicationGatewayAuthenticationCertificate = require('./applicationGatewayAuthenticationCertificate');
exports.ApplicationGatewayTrustedRootCertificate = require('./applicationGatewayTrustedRootCertificate');
exports.ApplicationGatewaySslCertificate = require('./applicationGatewaySslCertificate');
exports.ApplicationGatewayFrontendIPConfiguration = require('./applicationGatewayFrontendIPConfiguration');
exports.ApplicationGatewayFrontendPort = require('./applicationGatewayFrontendPort');
exports.ApplicationGatewayCustomError = require('./applicationGatewayCustomError');
exports.ApplicationGatewayHttpListener = require('./applicationGatewayHttpListener');
exports.ApplicationGatewayPathRule = require('./applicationGatewayPathRule');
exports.ApplicationGatewayProbe = require('./applicationGatewayProbe');
exports.ApplicationGatewayRequestRoutingRule = require('./applicationGatewayRequestRoutingRule');
exports.ApplicationGatewayRewriteRuleCondition = require('./applicationGatewayRewriteRuleCondition');
exports.ApplicationGatewayHeaderConfiguration = require('./applicationGatewayHeaderConfiguration');
exports.ApplicationGatewayRewriteRuleActionSet = require('./applicationGatewayRewriteRuleActionSet');
exports.ApplicationGatewayRewriteRule = require('./applicationGatewayRewriteRule');
exports.ApplicationGatewayRewriteRuleSet = require('./applicationGatewayRewriteRuleSet');
exports.ApplicationGatewayRedirectConfiguration = require('./applicationGatewayRedirectConfiguration');
exports.ApplicationGatewayUrlPathMap = require('./applicationGatewayUrlPathMap');
exports.ApplicationGatewayFirewallDisabledRuleGroup = require('./applicationGatewayFirewallDisabledRuleGroup');
exports.ApplicationGatewayFirewallExclusion = require('./applicationGatewayFirewallExclusion');
exports.ApplicationGatewayWebApplicationFirewallConfiguration = require('./applicationGatewayWebApplicationFirewallConfiguration');
exports.ApplicationGatewayAutoscaleConfiguration = require('./applicationGatewayAutoscaleConfiguration');
exports.ManagedServiceIdentityUserAssignedIdentitiesValue = require('./managedServiceIdentityUserAssignedIdentitiesValue');
exports.ManagedServiceIdentity = require('./managedServiceIdentity');
exports.ApplicationGateway = require('./applicationGateway');
exports.ApplicationGatewayFirewallRule = require('./applicationGatewayFirewallRule');
exports.ApplicationGatewayFirewallRuleGroup = require('./applicationGatewayFirewallRuleGroup');
exports.ApplicationGatewayFirewallRuleSet = require('./applicationGatewayFirewallRuleSet');
exports.ApplicationGatewayAvailableWafRuleSetsResult = require('./applicationGatewayAvailableWafRuleSetsResult');
exports.ApplicationGatewayAvailableSslOptions = require('./applicationGatewayAvailableSslOptions');
exports.ApplicationGatewaySslPredefinedPolicy = require('./applicationGatewaySslPredefinedPolicy');
exports.ErrorDetails = require('./errorDetails');
exports.ErrorModel = require('./errorModel');
exports.TagsObject = require('./tagsObject');
exports.AvailableDelegation = require('./availableDelegation');
exports.AzureFirewallIPConfiguration = require('./azureFirewallIPConfiguration');
exports.AzureFirewallRCAction = require('./azureFirewallRCAction');
exports.AzureFirewallApplicationRuleProtocol = require('./azureFirewallApplicationRuleProtocol');
exports.AzureFirewallApplicationRule = require('./azureFirewallApplicationRule');
exports.AzureFirewallApplicationRuleCollection = require('./azureFirewallApplicationRuleCollection');
exports.AzureFirewallNatRCAction = require('./azureFirewallNatRCAction');
exports.AzureFirewallNatRule = require('./azureFirewallNatRule');
exports.AzureFirewallNatRuleCollection = require('./azureFirewallNatRuleCollection');
exports.AzureFirewallNetworkRule = require('./azureFirewallNetworkRule');
exports.AzureFirewallNetworkRuleCollection = require('./azureFirewallNetworkRuleCollection');
exports.AzureFirewall = require('./azureFirewall');
exports.AzureFirewallFqdnTag = require('./azureFirewallFqdnTag');
exports.DnsNameAvailabilityResult = require('./dnsNameAvailabilityResult');
exports.ProtocolCustomSettingsFormat = require('./protocolCustomSettingsFormat');
exports.DdosCustomPolicy = require('./ddosCustomPolicy');
exports.DdosProtectionPlan = require('./ddosProtectionPlan');
exports.EndpointServiceResult = require('./endpointServiceResult');
exports.ExpressRouteCircuitAuthorization = require('./expressRouteCircuitAuthorization');
exports.ExpressRouteCircuitPeeringConfig = require('./expressRouteCircuitPeeringConfig');
exports.RouteFilterRule = require('./routeFilterRule');
exports.ExpressRouteCircuitStats = require('./expressRouteCircuitStats');
exports.ExpressRouteConnectionId = require('./expressRouteConnectionId');
exports.ExpressRouteCircuitConnection = require('./expressRouteCircuitConnection');
exports.PeerExpressRouteCircuitConnection = require('./peerExpressRouteCircuitConnection');
exports.ExpressRouteCircuitPeering = require('./expressRouteCircuitPeering');
exports.RouteFilter = require('./routeFilter');
exports.Ipv6ExpressRouteCircuitPeeringConfig = require('./ipv6ExpressRouteCircuitPeeringConfig');
exports.ExpressRouteCircuitSku = require('./expressRouteCircuitSku');
exports.ExpressRouteCircuitServiceProviderProperties = require('./expressRouteCircuitServiceProviderProperties');
exports.ExpressRouteCircuit = require('./expressRouteCircuit');
exports.ExpressRouteCircuitArpTable = require('./expressRouteCircuitArpTable');
exports.ExpressRouteCircuitsArpTableListResult = require('./expressRouteCircuitsArpTableListResult');
exports.ExpressRouteCircuitRoutesTable = require('./expressRouteCircuitRoutesTable');
exports.ExpressRouteCircuitsRoutesTableListResult = require('./expressRouteCircuitsRoutesTableListResult');
exports.ExpressRouteCircuitRoutesTableSummary = require('./expressRouteCircuitRoutesTableSummary');
exports.ExpressRouteCircuitsRoutesTableSummaryListResult = require('./expressRouteCircuitsRoutesTableSummaryListResult');
exports.ExpressRouteServiceProviderBandwidthsOffered = require('./expressRouteServiceProviderBandwidthsOffered');
exports.ExpressRouteServiceProvider = require('./expressRouteServiceProvider');
exports.ExpressRouteCrossConnectionRoutesTableSummary = require('./expressRouteCrossConnectionRoutesTableSummary');
exports.ExpressRouteCrossConnectionsRoutesTableSummaryListResult = require('./expressRouteCrossConnectionsRoutesTableSummaryListResult');
exports.ExpressRouteCircuitReference = require('./expressRouteCircuitReference');
exports.ExpressRouteCrossConnectionPeering = require('./expressRouteCrossConnectionPeering');
exports.ExpressRouteCrossConnection = require('./expressRouteCrossConnection');
exports.VirtualHubId = require('./virtualHubId');
exports.ExpressRouteCircuitPeeringId = require('./expressRouteCircuitPeeringId');
exports.ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds = require('./expressRouteGatewayPropertiesAutoScaleConfigurationBounds');
exports.ExpressRouteGatewayPropertiesAutoScaleConfiguration = require('./expressRouteGatewayPropertiesAutoScaleConfiguration');
exports.ExpressRouteConnection = require('./expressRouteConnection');
exports.ExpressRouteGateway = require('./expressRouteGateway');
exports.ExpressRouteGatewayList = require('./expressRouteGatewayList');
exports.ExpressRouteConnectionList = require('./expressRouteConnectionList');
exports.ExpressRoutePortsLocationBandwidths = require('./expressRoutePortsLocationBandwidths');
exports.ExpressRoutePortsLocation = require('./expressRoutePortsLocation');
exports.ExpressRouteLink = require('./expressRouteLink');
exports.ExpressRoutePort = require('./expressRoutePort');
exports.LoadBalancerSku = require('./loadBalancerSku');
exports.LoadBalancingRule = require('./loadBalancingRule');
exports.Probe = require('./probe');
exports.InboundNatPool = require('./inboundNatPool');
exports.OutboundRule = require('./outboundRule');
exports.LoadBalancer = require('./loadBalancer');
exports.NatGatewaySku = require('./natGatewaySku');
exports.NatGateway = require('./natGateway');
exports.AzureAsyncOperationResult = require('./azureAsyncOperationResult');
exports.EffectiveNetworkSecurityGroupAssociation = require('./effectiveNetworkSecurityGroupAssociation');
exports.EffectiveNetworkSecurityRule = require('./effectiveNetworkSecurityRule');
exports.EffectiveNetworkSecurityGroup = require('./effectiveNetworkSecurityGroup');
exports.EffectiveNetworkSecurityGroupListResult = require('./effectiveNetworkSecurityGroupListResult');
exports.EffectiveRoute = require('./effectiveRoute');
exports.EffectiveRouteListResult = require('./effectiveRouteListResult');
exports.ContainerNetworkInterfaceConfiguration = require('./containerNetworkInterfaceConfiguration');
exports.Container = require('./container');
exports.ContainerNetworkInterfaceIpConfiguration = require('./containerNetworkInterfaceIpConfiguration');
exports.ContainerNetworkInterface = require('./containerNetworkInterface');
exports.NetworkProfile = require('./networkProfile');
exports.ErrorResponse = require('./errorResponse');
exports.NetworkWatcher = require('./networkWatcher');
exports.TopologyParameters = require('./topologyParameters');
exports.TopologyAssociation = require('./topologyAssociation');
exports.TopologyResource = require('./topologyResource');
exports.Topology = require('./topology');
exports.VerificationIPFlowParameters = require('./verificationIPFlowParameters');
exports.VerificationIPFlowResult = require('./verificationIPFlowResult');
exports.NextHopParameters = require('./nextHopParameters');
exports.NextHopResult = require('./nextHopResult');
exports.SecurityGroupViewParameters = require('./securityGroupViewParameters');
exports.NetworkInterfaceAssociation = require('./networkInterfaceAssociation');
exports.SubnetAssociation = require('./subnetAssociation');
exports.SecurityRuleAssociations = require('./securityRuleAssociations');
exports.SecurityGroupNetworkInterface = require('./securityGroupNetworkInterface');
exports.SecurityGroupViewResult = require('./securityGroupViewResult');
exports.PacketCaptureStorageLocation = require('./packetCaptureStorageLocation');
exports.PacketCaptureFilter = require('./packetCaptureFilter');
exports.PacketCaptureParameters = require('./packetCaptureParameters');
exports.PacketCapture = require('./packetCapture');
exports.PacketCaptureResult = require('./packetCaptureResult');
exports.PacketCaptureQueryStatusResult = require('./packetCaptureQueryStatusResult');
exports.TroubleshootingParameters = require('./troubleshootingParameters');
exports.QueryTroubleshootingParameters = require('./queryTroubleshootingParameters');
exports.TroubleshootingRecommendedActions = require('./troubleshootingRecommendedActions');
exports.TroubleshootingDetails = require('./troubleshootingDetails');
exports.TroubleshootingResult = require('./troubleshootingResult');
exports.RetentionPolicyParameters = require('./retentionPolicyParameters');
exports.FlowLogFormatParameters = require('./flowLogFormatParameters');
exports.FlowLogStatusParameters = require('./flowLogStatusParameters');
exports.TrafficAnalyticsConfigurationProperties = require('./trafficAnalyticsConfigurationProperties');
exports.TrafficAnalyticsProperties = require('./trafficAnalyticsProperties');
exports.FlowLogInformation = require('./flowLogInformation');
exports.ConnectivitySource = require('./connectivitySource');
exports.ConnectivityDestination = require('./connectivityDestination');
exports.HTTPHeader = require('./hTTPHeader');
exports.HTTPConfiguration = require('./hTTPConfiguration');
exports.ProtocolConfiguration = require('./protocolConfiguration');
exports.ConnectivityParameters = require('./connectivityParameters');
exports.ConnectivityIssue = require('./connectivityIssue');
exports.ConnectivityHop = require('./connectivityHop');
exports.ConnectivityInformation = require('./connectivityInformation');
exports.AzureReachabilityReportLocation = require('./azureReachabilityReportLocation');
exports.AzureReachabilityReportParameters = require('./azureReachabilityReportParameters');
exports.AzureReachabilityReportLatencyInfo = require('./azureReachabilityReportLatencyInfo');
exports.AzureReachabilityReportItem = require('./azureReachabilityReportItem');
exports.AzureReachabilityReport = require('./azureReachabilityReport');
exports.AvailableProvidersListParameters = require('./availableProvidersListParameters');
exports.AvailableProvidersListCity = require('./availableProvidersListCity');
exports.AvailableProvidersListState = require('./availableProvidersListState');
exports.AvailableProvidersListCountry = require('./availableProvidersListCountry');
exports.AvailableProvidersList = require('./availableProvidersList');
exports.ConnectionMonitorSource = require('./connectionMonitorSource');
exports.ConnectionMonitorDestination = require('./connectionMonitorDestination');
exports.ConnectionMonitorParameters = require('./connectionMonitorParameters');
exports.ConnectionMonitor = require('./connectionMonitor');
exports.ConnectionMonitorResult = require('./connectionMonitorResult');
exports.ConnectionStateSnapshot = require('./connectionStateSnapshot');
exports.ConnectionMonitorQueryResult = require('./connectionMonitorQueryResult');
exports.NetworkConfigurationDiagnosticProfile = require('./networkConfigurationDiagnosticProfile');
exports.NetworkConfigurationDiagnosticParameters = require('./networkConfigurationDiagnosticParameters');
exports.MatchedRule = require('./matchedRule');
exports.NetworkSecurityRulesEvaluationResult = require('./networkSecurityRulesEvaluationResult');
exports.EvaluatedNetworkSecurityGroup = require('./evaluatedNetworkSecurityGroup');
exports.NetworkSecurityGroupResult = require('./networkSecurityGroupResult');
exports.NetworkConfigurationDiagnosticResult = require('./networkConfigurationDiagnosticResult');
exports.NetworkConfigurationDiagnosticResponse = require('./networkConfigurationDiagnosticResponse');
exports.OperationDisplay = require('./operationDisplay');
exports.Availability = require('./availability');
exports.Dimension = require('./dimension');
exports.MetricSpecification = require('./metricSpecification');
exports.LogSpecification = require('./logSpecification');
exports.OperationPropertiesFormatServiceSpecification = require('./operationPropertiesFormatServiceSpecification');
exports.Operation = require('./operation');
exports.PublicIPPrefixSku = require('./publicIPPrefixSku');
exports.ReferencedPublicIpAddress = require('./referencedPublicIpAddress');
exports.PublicIPPrefix = require('./publicIPPrefix');
exports.PatchRouteFilterRule = require('./patchRouteFilterRule');
exports.PatchRouteFilter = require('./patchRouteFilter');
exports.BGPCommunity = require('./bGPCommunity');
exports.BgpServiceCommunity = require('./bgpServiceCommunity');
exports.UsageName = require('./usageName');
exports.Usage = require('./usage');
exports.AddressSpace = require('./addressSpace');
exports.VirtualNetworkPeering = require('./virtualNetworkPeering');
exports.DhcpOptions = require('./dhcpOptions');
exports.VirtualNetwork = require('./virtualNetwork');
exports.IPAddressAvailabilityResult = require('./iPAddressAvailabilityResult');
exports.VirtualNetworkUsageName = require('./virtualNetworkUsageName');
exports.VirtualNetworkUsage = require('./virtualNetworkUsage');
exports.NetworkIntentPolicy = require('./networkIntentPolicy');
exports.NetworkIntentPolicyConfiguration = require('./networkIntentPolicyConfiguration');
exports.PrepareNetworkPoliciesRequest = require('./prepareNetworkPoliciesRequest');
exports.VirtualNetworkGatewayIPConfiguration = require('./virtualNetworkGatewayIPConfiguration');
exports.VirtualNetworkGatewaySku = require('./virtualNetworkGatewaySku');
exports.VpnClientRootCertificate = require('./vpnClientRootCertificate');
exports.VpnClientRevokedCertificate = require('./vpnClientRevokedCertificate');
exports.IpsecPolicy = require('./ipsecPolicy');
exports.VpnClientConfiguration = require('./vpnClientConfiguration');
exports.BgpSettings = require('./bgpSettings');
exports.BgpPeerStatus = require('./bgpPeerStatus');
exports.GatewayRoute = require('./gatewayRoute');
exports.VirtualNetworkGateway = require('./virtualNetworkGateway');
exports.VpnClientParameters = require('./vpnClientParameters');
exports.BgpPeerStatusListResult = require('./bgpPeerStatusListResult');
exports.GatewayRouteListResult = require('./gatewayRouteListResult');
exports.TunnelConnectionHealth = require('./tunnelConnectionHealth');
exports.LocalNetworkGateway = require('./localNetworkGateway');
exports.VirtualNetworkGatewayConnection = require('./virtualNetworkGatewayConnection');
exports.ConnectionResetSharedKey = require('./connectionResetSharedKey');
exports.ConnectionSharedKey = require('./connectionSharedKey');
exports.VpnClientIPsecParameters = require('./vpnClientIPsecParameters');
exports.VirtualNetworkConnectionGatewayReference = require('./virtualNetworkConnectionGatewayReference');
exports.VirtualNetworkGatewayConnectionListEntity = require('./virtualNetworkGatewayConnectionListEntity');
exports.VpnDeviceScriptParameters = require('./vpnDeviceScriptParameters');
exports.P2SVpnServerConfigVpnClientRootCertificate = require('./p2SVpnServerConfigVpnClientRootCertificate');
exports.P2SVpnServerConfigVpnClientRevokedCertificate = require('./p2SVpnServerConfigVpnClientRevokedCertificate');
exports.P2SVpnServerConfigRadiusServerRootCertificate = require('./p2SVpnServerConfigRadiusServerRootCertificate');
exports.P2SVpnServerConfigRadiusClientRootCertificate = require('./p2SVpnServerConfigRadiusClientRootCertificate');
exports.P2SVpnServerConfiguration = require('./p2SVpnServerConfiguration');
exports.VirtualWAN = require('./virtualWAN');
exports.DeviceProperties = require('./deviceProperties');
exports.VpnSite = require('./vpnSite');
exports.GetVpnSitesConfigurationRequest = require('./getVpnSitesConfigurationRequest');
exports.HubVirtualNetworkConnection = require('./hubVirtualNetworkConnection');
exports.VirtualHubRoute = require('./virtualHubRoute');
exports.VirtualHubRouteTable = require('./virtualHubRouteTable');
exports.VirtualHub = require('./virtualHub');
exports.VpnConnection = require('./vpnConnection');
exports.VpnGateway = require('./vpnGateway');
exports.VpnSiteId = require('./vpnSiteId');
exports.VirtualWanSecurityProvider = require('./virtualWanSecurityProvider');
exports.VirtualWanSecurityProviders = require('./virtualWanSecurityProviders');
exports.VpnClientConnectionHealth = require('./vpnClientConnectionHealth');
exports.P2SVpnGateway = require('./p2SVpnGateway');
exports.P2SVpnProfileParameters = require('./p2SVpnProfileParameters');
exports.VpnProfileResponse = require('./vpnProfileResponse');
exports.PolicySettings = require('./policySettings');
exports.MatchVariable = require('./matchVariable');
exports.MatchCondition = require('./matchCondition');
exports.WebApplicationFirewallCustomRule = require('./webApplicationFirewallCustomRule');
exports.WebApplicationFirewallPolicy = require('./webApplicationFirewallPolicy');
exports.ApplicationGatewayListResult = require('./applicationGatewayListResult');
exports.ApplicationGatewayAvailableSslPredefinedPolicies = require('./applicationGatewayAvailableSslPredefinedPolicies');
exports.ApplicationSecurityGroupListResult = require('./applicationSecurityGroupListResult');
exports.AvailableDelegationsResult = require('./availableDelegationsResult');
exports.AzureFirewallListResult = require('./azureFirewallListResult');
exports.AzureFirewallFqdnTagListResult = require('./azureFirewallFqdnTagListResult');
exports.DdosProtectionPlanListResult = require('./ddosProtectionPlanListResult');
exports.EndpointServicesListResult = require('./endpointServicesListResult');
exports.AuthorizationListResult = require('./authorizationListResult');
exports.ExpressRouteCircuitPeeringListResult = require('./expressRouteCircuitPeeringListResult');
exports.ExpressRouteCircuitConnectionListResult = require('./expressRouteCircuitConnectionListResult');
exports.PeerExpressRouteCircuitConnectionListResult = require('./peerExpressRouteCircuitConnectionListResult');
exports.ExpressRouteCircuitListResult = require('./expressRouteCircuitListResult');
exports.ExpressRouteServiceProviderListResult = require('./expressRouteServiceProviderListResult');
exports.ExpressRouteCrossConnectionListResult = require('./expressRouteCrossConnectionListResult');
exports.ExpressRouteCrossConnectionPeeringList = require('./expressRouteCrossConnectionPeeringList');
exports.ExpressRoutePortsLocationListResult = require('./expressRoutePortsLocationListResult');
exports.ExpressRoutePortListResult = require('./expressRoutePortListResult');
exports.ExpressRouteLinkListResult = require('./expressRouteLinkListResult');
exports.InterfaceEndpointListResult = require('./interfaceEndpointListResult');
exports.LoadBalancerListResult = require('./loadBalancerListResult');
exports.LoadBalancerBackendAddressPoolListResult = require('./loadBalancerBackendAddressPoolListResult');
exports.LoadBalancerFrontendIPConfigurationListResult = require('./loadBalancerFrontendIPConfigurationListResult');
exports.InboundNatRuleListResult = require('./inboundNatRuleListResult');
exports.LoadBalancerLoadBalancingRuleListResult = require('./loadBalancerLoadBalancingRuleListResult');
exports.LoadBalancerOutboundRuleListResult = require('./loadBalancerOutboundRuleListResult');
exports.NetworkInterfaceListResult = require('./networkInterfaceListResult');
exports.LoadBalancerProbeListResult = require('./loadBalancerProbeListResult');
exports.NatGatewayListResult = require('./natGatewayListResult');
exports.NetworkInterfaceIPConfigurationListResult = require('./networkInterfaceIPConfigurationListResult');
exports.NetworkInterfaceLoadBalancerListResult = require('./networkInterfaceLoadBalancerListResult');
exports.NetworkInterfaceTapConfigurationListResult = require('./networkInterfaceTapConfigurationListResult');
exports.NetworkProfileListResult = require('./networkProfileListResult');
exports.NetworkSecurityGroupListResult = require('./networkSecurityGroupListResult');
exports.SecurityRuleListResult = require('./securityRuleListResult');
exports.NetworkWatcherListResult = require('./networkWatcherListResult');
exports.PacketCaptureListResult = require('./packetCaptureListResult');
exports.ConnectionMonitorListResult = require('./connectionMonitorListResult');
exports.OperationListResult = require('./operationListResult');
exports.PublicIPAddressListResult = require('./publicIPAddressListResult');
exports.PublicIPPrefixListResult = require('./publicIPPrefixListResult');
exports.RouteFilterListResult = require('./routeFilterListResult');
exports.RouteFilterRuleListResult = require('./routeFilterRuleListResult');
exports.RouteTableListResult = require('./routeTableListResult');
exports.RouteListResult = require('./routeListResult');
exports.BgpServiceCommunityListResult = require('./bgpServiceCommunityListResult');
exports.ServiceEndpointPolicyListResult = require('./serviceEndpointPolicyListResult');
exports.ServiceEndpointPolicyDefinitionListResult = require('./serviceEndpointPolicyDefinitionListResult');
exports.UsagesListResult = require('./usagesListResult');
exports.VirtualNetworkListResult = require('./virtualNetworkListResult');
exports.VirtualNetworkListUsageResult = require('./virtualNetworkListUsageResult');
exports.SubnetListResult = require('./subnetListResult');
exports.VirtualNetworkPeeringListResult = require('./virtualNetworkPeeringListResult');
exports.VirtualNetworkGatewayListResult = require('./virtualNetworkGatewayListResult');
exports.VirtualNetworkGatewayListConnectionsResult = require('./virtualNetworkGatewayListConnectionsResult');
exports.VirtualNetworkGatewayConnectionListResult = require('./virtualNetworkGatewayConnectionListResult');
exports.LocalNetworkGatewayListResult = require('./localNetworkGatewayListResult');
exports.VirtualNetworkTapListResult = require('./virtualNetworkTapListResult');
exports.ListVirtualWANsResult = require('./listVirtualWANsResult');
exports.ListVpnSitesResult = require('./listVpnSitesResult');
exports.ListVirtualHubsResult = require('./listVirtualHubsResult');
exports.ListHubVirtualNetworkConnectionsResult = require('./listHubVirtualNetworkConnectionsResult');
exports.ListVpnGatewaysResult = require('./listVpnGatewaysResult');
exports.ListVpnConnectionsResult = require('./listVpnConnectionsResult');
exports.ListP2SVpnServerConfigurationsResult = require('./listP2SVpnServerConfigurationsResult');
exports.ListP2SVpnGatewaysResult = require('./listP2SVpnGatewaysResult');
exports.WebApplicationFirewallPolicyListResult = require('./webApplicationFirewallPolicyListResult');
