/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Define match variables
 *
 */
class MatchVariable {
  /**
   * Create a MatchVariable.
   * @property {string} variableName Match Variable. Possible values include:
   * 'RemoteAddr', 'RequestMethod', 'QueryString', 'PostArgs', 'RequestUri',
   * 'RequestHeaders', 'RequestBody', 'RequestCookies'
   * @property {string} [selector] Describes field of the matchVariable
   * collection
   */
  constructor() {
  }

  /**
   * Defines the metadata of MatchVariable
   *
   * @returns {object} metadata of MatchVariable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MatchVariable',
      type: {
        name: 'Composite',
        className: 'MatchVariable',
        modelProperties: {
          variableName: {
            required: true,
            serializedName: 'variableName',
            type: {
              name: 'String'
            }
          },
          selector: {
            required: false,
            serializedName: 'selector',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MatchVariable;
