/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters to get network configuration diagnostic.
 *
 */
class NetworkConfigurationDiagnosticParameters {
  /**
   * Create a NetworkConfigurationDiagnosticParameters.
   * @property {string} targetResourceId The ID of the target resource to
   * perform network configuration diagnostic. Valid options are VM,
   * NetworkInterface, VMSS/NetworkInterface and Application Gateway.
   * @property {string} [verbosityLevel] Verbosity level. Accepted values are
   * 'Normal', 'Minimum', 'Full'. Possible values include: 'Normal', 'Minimum',
   * 'Full'
   * @property {array} profiles List of network configuration diagnostic
   * profiles.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkConfigurationDiagnosticParameters
   *
   * @returns {object} metadata of NetworkConfigurationDiagnosticParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkConfigurationDiagnosticParameters',
      type: {
        name: 'Composite',
        className: 'NetworkConfigurationDiagnosticParameters',
        modelProperties: {
          targetResourceId: {
            required: true,
            serializedName: 'targetResourceId',
            type: {
              name: 'String'
            }
          },
          verbosityLevel: {
            required: false,
            serializedName: 'verbosityLevel',
            type: {
              name: 'String'
            }
          },
          profiles: {
            required: true,
            serializedName: 'profiles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NetworkConfigurationDiagnosticProfileElementType',
                  type: {
                    name: 'Composite',
                    className: 'NetworkConfigurationDiagnosticProfile'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkConfigurationDiagnosticParameters;
