/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details of NetworkIntentPolicyConfiguration for
 * PrepareNetworkPoliciesRequest.
 *
 */
class NetworkIntentPolicyConfiguration {
  /**
   * Create a NetworkIntentPolicyConfiguration.
   * @property {string} [networkIntentPolicyName] The name of the Network
   * Intent Policy for storing in target subscription.
   * @property {object} [sourceNetworkIntentPolicy] Source network intent
   * policy.
   * @property {string} [sourceNetworkIntentPolicy.etag] Gets a unique
   * read-only string that changes whenever the resource is updated.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkIntentPolicyConfiguration
   *
   * @returns {object} metadata of NetworkIntentPolicyConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkIntentPolicyConfiguration',
      type: {
        name: 'Composite',
        className: 'NetworkIntentPolicyConfiguration',
        modelProperties: {
          networkIntentPolicyName: {
            required: false,
            serializedName: 'networkIntentPolicyName',
            type: {
              name: 'String'
            }
          },
          sourceNetworkIntentPolicy: {
            required: false,
            serializedName: 'sourceNetworkIntentPolicy',
            type: {
              name: 'Composite',
              className: 'NetworkIntentPolicy'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkIntentPolicyConfiguration;
