/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Network interface and its custom security rules.
 *
 */
class NetworkInterfaceAssociation {
  /**
   * Create a NetworkInterfaceAssociation.
   * @property {string} [id] Network interface ID.
   * @property {array} [securityRules] Collection of custom security rules.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkInterfaceAssociation
   *
   * @returns {object} metadata of NetworkInterfaceAssociation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkInterfaceAssociation',
      type: {
        name: 'Composite',
        className: 'NetworkInterfaceAssociation',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          securityRules: {
            required: false,
            serializedName: 'securityRules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SecurityRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'SecurityRule'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkInterfaceAssociation;
