/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Network profile resource.
 *
 * @extends models['Resource']
 */
class NetworkProfile extends models['Resource'] {
  /**
   * Create a NetworkProfile.
   * @property {array} [containerNetworkInterfaces] List of child container
   * network interfaces.
   * @property {array} [containerNetworkInterfaceConfigurations] List of chid
   * container network interface configurations.
   * @property {string} [resourceGuid] The resource GUID property of the
   * network interface resource.
   * @property {string} [provisioningState] The provisioning state of the
   * resource.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NetworkProfile
   *
   * @returns {object} metadata of NetworkProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkProfile',
      type: {
        name: 'Composite',
        className: 'NetworkProfile',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          containerNetworkInterfaces: {
            required: false,
            serializedName: 'properties.containerNetworkInterfaces',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ContainerNetworkInterfaceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ContainerNetworkInterface'
                  }
              }
            }
          },
          containerNetworkInterfaceConfigurations: {
            required: false,
            serializedName: 'properties.containerNetworkInterfaceConfigurations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ContainerNetworkInterfaceConfigurationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ContainerNetworkInterfaceConfiguration'
                  }
              }
            }
          },
          resourceGuid: {
            required: false,
            readOnly: true,
            serializedName: 'properties.resourceGuid',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkProfile;
