/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Network configuration diagnostic result corresponded provided traffic query.
 *
 */
class NetworkSecurityGroupResult {
  /**
   * Create a NetworkSecurityGroupResult.
   * @property {string} [securityRuleAccessResult] The network traffic is
   * allowed or denied. Possible values include: 'Allow', 'Deny'
   * @property {array} [evaluatedNetworkSecurityGroups] List of results network
   * security groups diagnostic.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkSecurityGroupResult
   *
   * @returns {object} metadata of NetworkSecurityGroupResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkSecurityGroupResult',
      type: {
        name: 'Composite',
        className: 'NetworkSecurityGroupResult',
        modelProperties: {
          securityRuleAccessResult: {
            required: false,
            serializedName: 'securityRuleAccessResult',
            type: {
              name: 'String'
            }
          },
          evaluatedNetworkSecurityGroups: {
            required: false,
            readOnly: true,
            serializedName: 'evaluatedNetworkSecurityGroups',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EvaluatedNetworkSecurityGroupElementType',
                  type: {
                    name: 'Composite',
                    className: 'EvaluatedNetworkSecurityGroup'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkSecurityGroupResult;
