/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Network security rules evaluation result.
 *
 */
class NetworkSecurityRulesEvaluationResult {
  /**
   * Create a NetworkSecurityRulesEvaluationResult.
   * @property {string} [name] Name of the network security rule.
   * @property {boolean} [protocolMatched] Value indicating whether protocol is
   * matched.
   * @property {boolean} [sourceMatched] Value indicating whether source is
   * matched.
   * @property {boolean} [sourcePortMatched] Value indicating whether source
   * port is matched.
   * @property {boolean} [destinationMatched] Value indicating whether
   * destination is matched.
   * @property {boolean} [destinationPortMatched] Value indicating whether
   * destination port is matched.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkSecurityRulesEvaluationResult
   *
   * @returns {object} metadata of NetworkSecurityRulesEvaluationResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkSecurityRulesEvaluationResult',
      type: {
        name: 'Composite',
        className: 'NetworkSecurityRulesEvaluationResult',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          protocolMatched: {
            required: false,
            serializedName: 'protocolMatched',
            type: {
              name: 'Boolean'
            }
          },
          sourceMatched: {
            required: false,
            serializedName: 'sourceMatched',
            type: {
              name: 'Boolean'
            }
          },
          sourcePortMatched: {
            required: false,
            serializedName: 'sourcePortMatched',
            type: {
              name: 'Boolean'
            }
          },
          destinationMatched: {
            required: false,
            serializedName: 'destinationMatched',
            type: {
              name: 'Boolean'
            }
          },
          destinationPortMatched: {
            required: false,
            serializedName: 'destinationPortMatched',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkSecurityRulesEvaluationResult;
