/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specification of the service.
 *
 */
class OperationPropertiesFormatServiceSpecification {
  /**
   * Create a OperationPropertiesFormatServiceSpecification.
   * @property {array} [metricSpecifications] Operation service specification.
   * @property {array} [logSpecifications] Operation log specification.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationPropertiesFormatServiceSpecification
   *
   * @returns {object} metadata of OperationPropertiesFormatServiceSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationPropertiesFormat_serviceSpecification',
      type: {
        name: 'Composite',
        className: 'OperationPropertiesFormatServiceSpecification',
        modelProperties: {
          metricSpecifications: {
            required: false,
            serializedName: 'metricSpecifications',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetricSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetricSpecification'
                  }
              }
            }
          },
          logSpecifications: {
            required: false,
            serializedName: 'logSpecifications',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LogSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'LogSpecification'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OperationPropertiesFormatServiceSpecification;
