/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines contents of a web application firewall global configuration
 *
 */
class PolicySettings {
  /**
   * Create a PolicySettings.
   * @property {string} [enabledState] Describes if the policy is in enabled
   * state or disabled state. Possible values include: 'Disabled', 'Enabled'
   * @property {string} [mode] Describes if it is in detection mode  or
   * prevention mode at policy level. Possible values include: 'Prevention',
   * 'Detection'
   */
  constructor() {
  }

  /**
   * Defines the metadata of PolicySettings
   *
   * @returns {object} metadata of PolicySettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolicySettings',
      type: {
        name: 'Composite',
        className: 'PolicySettings',
        modelProperties: {
          enabledState: {
            required: false,
            serializedName: 'enabledState',
            type: {
              name: 'String'
            }
          },
          mode: {
            required: false,
            serializedName: 'mode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PolicySettings;
