/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details of PrepareNetworkPolicies for Subnet.
 *
 */
class PrepareNetworkPoliciesRequest {
  /**
   * Create a PrepareNetworkPoliciesRequest.
   * @property {string} [serviceName] The name of the service for which subnet
   * is being prepared for.
   * @property {string} [resourceGroupName] The name of the resource group
   * where the Network Intent Policy will be stored.
   * @property {array} [networkIntentPolicyConfigurations] A list of
   * NetworkIntentPolicyConfiguration.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrepareNetworkPoliciesRequest
   *
   * @returns {object} metadata of PrepareNetworkPoliciesRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrepareNetworkPoliciesRequest',
      type: {
        name: 'Composite',
        className: 'PrepareNetworkPoliciesRequest',
        modelProperties: {
          serviceName: {
            required: false,
            serializedName: 'serviceName',
            type: {
              name: 'String'
            }
          },
          resourceGroupName: {
            required: false,
            serializedName: 'resourceGroupName',
            type: {
              name: 'String'
            }
          },
          networkIntentPolicyConfigurations: {
            required: false,
            serializedName: 'networkIntentPolicyConfigurations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NetworkIntentPolicyConfigurationElementType',
                  type: {
                    name: 'Composite',
                    className: 'NetworkIntentPolicyConfiguration'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PrepareNetworkPoliciesRequest;
