/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Configuration of the protocol.
 *
 */
class ProtocolConfiguration {
  /**
   * Create a ProtocolConfiguration.
   * @property {object} [hTTPConfiguration] HTTP configuration of the
   * connectivity check.
   * @property {string} [hTTPConfiguration.method] HTTP method. Possible values
   * include: 'Get'
   * @property {array} [hTTPConfiguration.headers] List of HTTP headers.
   * @property {array} [hTTPConfiguration.validStatusCodes] Valid status codes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProtocolConfiguration
   *
   * @returns {object} metadata of ProtocolConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtocolConfiguration',
      type: {
        name: 'Composite',
        className: 'ProtocolConfiguration',
        modelProperties: {
          hTTPConfiguration: {
            required: false,
            serializedName: 'HTTPConfiguration',
            type: {
              name: 'Composite',
              className: 'HTTPConfiguration'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtocolConfiguration;
