/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * DDoS custom policy properties.
 *
 */
class ProtocolCustomSettingsFormat {
  /**
   * Create a ProtocolCustomSettingsFormat.
   * @property {string} [protocol] The protocol for which the DDoS protection
   * policy is being customized. Possible values include: 'Tcp', 'Udp', 'Syn'
   * @property {string} [triggerRateOverride] The customized DDoS protection
   * trigger rate.
   * @property {string} [sourceRateOverride] The customized DDoS protection
   * source rate.
   * @property {string} [triggerSensitivityOverride] The customized DDoS
   * protection trigger rate sensitivity degrees. High: Trigger rate set with
   * most sensitivity w.r.t. normal traffic. Default: Trigger rate set with
   * moderate sensitivity w.r.t. normal traffic. Low: Trigger rate set with
   * less sensitivity w.r.t. normal traffic. Relaxed: Trigger rate set with
   * least sensitivity w.r.t. normal traffic. Possible values include:
   * 'Relaxed', 'Low', 'Default', 'High'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProtocolCustomSettingsFormat
   *
   * @returns {object} metadata of ProtocolCustomSettingsFormat
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtocolCustomSettingsFormat',
      type: {
        name: 'Composite',
        className: 'ProtocolCustomSettingsFormat',
        modelProperties: {
          protocol: {
            required: false,
            serializedName: 'protocol',
            type: {
              name: 'String'
            }
          },
          triggerRateOverride: {
            required: false,
            serializedName: 'triggerRateOverride',
            type: {
              name: 'String'
            }
          },
          sourceRateOverride: {
            required: false,
            serializedName: 'sourceRateOverride',
            type: {
              name: 'String'
            }
          },
          triggerSensitivityOverride: {
            required: false,
            serializedName: 'triggerSensitivityOverride',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtocolCustomSettingsFormat;
