/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters that define the retention policy for flow log.
 *
 */
class RetentionPolicyParameters {
  /**
   * Create a RetentionPolicyParameters.
   * @property {number} [days] Number of days to retain flow log records.
   * Default value: 0 .
   * @property {boolean} [enabled] Flag to enable/disable retention. Default
   * value: false .
   */
  constructor() {
  }

  /**
   * Defines the metadata of RetentionPolicyParameters
   *
   * @returns {object} metadata of RetentionPolicyParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RetentionPolicyParameters',
      type: {
        name: 'Composite',
        className: 'RetentionPolicyParameters',
        modelProperties: {
          days: {
            required: false,
            serializedName: 'days',
            defaultValue: 0,
            type: {
              name: 'Number'
            }
          },
          enabled: {
            required: false,
            serializedName: 'enabled',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = RetentionPolicyParameters;
