/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response for ListSecurityRule API service call. Retrieves all security rules
 * that belongs to a network security group.
 */
class SecurityRuleListResult extends Array {
  /**
   * Create a SecurityRuleListResult.
   * @property {string} [nextLink] The URL to get the next set of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SecurityRuleListResult
   *
   * @returns {object} metadata of SecurityRuleListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecurityRuleListResult',
      type: {
        name: 'Composite',
        className: 'SecurityRuleListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SecurityRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'SecurityRule'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecurityRuleListResult;
