/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Service Endpoint policy definitions.
 *
 * @extends models['SubResource']
 */
class ServiceEndpointPolicyDefinition extends models['SubResource'] {
  /**
   * Create a ServiceEndpointPolicyDefinition.
   * @property {string} [description] A description for this rule. Restricted
   * to 140 chars.
   * @property {string} [service] Service endpoint name.
   * @property {array} [serviceResources] A list of service resources.
   * @property {string} [provisioningState] The provisioning state of the
   * service end point policy definition. Possible values are: 'Updating',
   * 'Deleting', and 'Failed'.
   * @property {string} [name] The name of the resource that is unique within a
   * resource group. This name can be used to access the resource.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceEndpointPolicyDefinition
   *
   * @returns {object} metadata of ServiceEndpointPolicyDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceEndpointPolicyDefinition',
      type: {
        name: 'Composite',
        className: 'ServiceEndpointPolicyDefinition',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          service: {
            required: false,
            serializedName: 'properties.service',
            type: {
              name: 'String'
            }
          },
          serviceResources: {
            required: false,
            serializedName: 'properties.serviceResources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceEndpointPolicyDefinition;
