/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Subnet and it's custom security rules.
 *
 */
class SubnetAssociation {
  /**
   * Create a SubnetAssociation.
   * @property {string} [id] Subnet ID.
   * @property {array} [securityRules] Collection of custom security rules.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubnetAssociation
   *
   * @returns {object} metadata of SubnetAssociation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubnetAssociation',
      type: {
        name: 'Composite',
        className: 'SubnetAssociation',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          securityRules: {
            required: false,
            serializedName: 'securityRules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SecurityRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'SecurityRule'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SubnetAssociation;
