/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The network resource topology information for the given resource group.
 *
 */
class TopologyResource {
  /**
   * Create a TopologyResource.
   * @property {string} [name] Name of the resource.
   * @property {string} [id] ID of the resource.
   * @property {string} [location] Resource location.
   * @property {array} [associations] Holds the associations the resource has
   * with other resources in the resource group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TopologyResource
   *
   * @returns {object} metadata of TopologyResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TopologyResource',
      type: {
        name: 'Composite',
        className: 'TopologyResource',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          associations: {
            required: false,
            serializedName: 'associations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TopologyAssociationElementType',
                  type: {
                    name: 'Composite',
                    className: 'TopologyAssociation'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TopologyResource;
