/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters that define the resource to troubleshoot.
 *
 */
class TroubleshootingParameters {
  /**
   * Create a TroubleshootingParameters.
   * @property {string} targetResourceId The target resource to troubleshoot.
   * @property {string} storageId The ID for the storage account to save the
   * troubleshoot result.
   * @property {string} storagePath The path to the blob to save the
   * troubleshoot result in.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TroubleshootingParameters
   *
   * @returns {object} metadata of TroubleshootingParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TroubleshootingParameters',
      type: {
        name: 'Composite',
        className: 'TroubleshootingParameters',
        modelProperties: {
          targetResourceId: {
            required: true,
            serializedName: 'targetResourceId',
            type: {
              name: 'String'
            }
          },
          storageId: {
            required: true,
            serializedName: 'properties.storageId',
            type: {
              name: 'String'
            }
          },
          storagePath: {
            required: true,
            serializedName: 'properties.storagePath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TroubleshootingParameters;
