/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Results of IP flow verification on the target resource.
 *
 */
class VerificationIPFlowResult {
  /**
   * Create a VerificationIPFlowResult.
   * @property {string} [access] Indicates whether the traffic is allowed or
   * denied. Possible values include: 'Allow', 'Deny'
   * @property {string} [ruleName] Name of the rule. If input is not matched
   * against any security rule, it is not displayed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VerificationIPFlowResult
   *
   * @returns {object} metadata of VerificationIPFlowResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VerificationIPFlowResult',
      type: {
        name: 'Composite',
        className: 'VerificationIPFlowResult',
        modelProperties: {
          access: {
            required: false,
            serializedName: 'access',
            type: {
              name: 'String'
            }
          },
          ruleName: {
            required: false,
            serializedName: 'ruleName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VerificationIPFlowResult;
