/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IP configuration for virtual network gateway
 *
 * @extends models['SubResource']
 */
class VirtualNetworkGatewayIPConfiguration extends models['SubResource'] {
  /**
   * Create a VirtualNetworkGatewayIPConfiguration.
   * @property {string} [privateIPAllocationMethod] The private IP address
   * allocation method. Possible values include: 'Static', 'Dynamic'
   * @property {object} [subnet] The reference of the subnet resource.
   * @property {string} [subnet.id] Resource ID.
   * @property {object} [publicIPAddress] The reference of the public IP
   * resource.
   * @property {string} [publicIPAddress.id] Resource ID.
   * @property {string} [provisioningState] The provisioning state of the
   * public IP resource. Possible values are: 'Updating', 'Deleting', and
   * 'Failed'.
   * @property {string} [name] The name of the resource that is unique within a
   * resource group. This name can be used to access the resource.
   * @property {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualNetworkGatewayIPConfiguration
   *
   * @returns {object} metadata of VirtualNetworkGatewayIPConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualNetworkGatewayIPConfiguration',
      type: {
        name: 'Composite',
        className: 'VirtualNetworkGatewayIPConfiguration',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          privateIPAllocationMethod: {
            required: false,
            serializedName: 'properties.privateIPAllocationMethod',
            type: {
              name: 'String'
            }
          },
          subnet: {
            required: false,
            serializedName: 'properties.subnet',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          publicIPAddress: {
            required: false,
            serializedName: 'properties.publicIPAddress',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualNetworkGatewayIPConfiguration;
