/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * VirtualNetworkGatewaySku details
 *
 */
class VirtualNetworkGatewaySku {
  /**
   * Create a VirtualNetworkGatewaySku.
   * @property {string} [name] Gateway SKU name. Possible values include:
   * 'Basic', 'HighPerformance', 'Standard', 'UltraPerformance', 'VpnGw1',
   * 'VpnGw2', 'VpnGw3', 'VpnGw1AZ', 'VpnGw2AZ', 'VpnGw3AZ', 'ErGw1AZ',
   * 'ErGw2AZ', 'ErGw3AZ'
   * @property {string} [tier] Gateway SKU tier. Possible values include:
   * 'Basic', 'HighPerformance', 'Standard', 'UltraPerformance', 'VpnGw1',
   * 'VpnGw2', 'VpnGw3', 'VpnGw1AZ', 'VpnGw2AZ', 'VpnGw3AZ', 'ErGw1AZ',
   * 'ErGw2AZ', 'ErGw3AZ'
   * @property {number} [capacity] The capacity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualNetworkGatewaySku
   *
   * @returns {object} metadata of VirtualNetworkGatewaySku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualNetworkGatewaySku',
      type: {
        name: 'Composite',
        className: 'VirtualNetworkGatewaySku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualNetworkGatewaySku;
