/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Collection of SecurityProviders.
 *
 */
class VirtualWanSecurityProvider {
  /**
   * Create a VirtualWanSecurityProvider.
   * @property {string} [name] Name of the security provider.
   * @property {string} [url] Url of the security provider.
   * @property {string} [type] Name of the security provider. Possible values
   * include: 'External', 'Native'
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualWanSecurityProvider
   *
   * @returns {object} metadata of VirtualWanSecurityProvider
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualWanSecurityProvider',
      type: {
        name: 'Composite',
        className: 'VirtualWanSecurityProvider',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualWanSecurityProvider;
