/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Vpn device configuration script generation parameters
 *
 */
class VpnDeviceScriptParameters {
  /**
   * Create a VpnDeviceScriptParameters.
   * @property {string} [vendor] The vendor for the vpn device.
   * @property {string} [deviceFamily] The device family for the vpn device.
   * @property {string} [firmwareVersion] The firmware version for the vpn
   * device.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VpnDeviceScriptParameters
   *
   * @returns {object} metadata of VpnDeviceScriptParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VpnDeviceScriptParameters',
      type: {
        name: 'Composite',
        className: 'VpnDeviceScriptParameters',
        modelProperties: {
          vendor: {
            required: false,
            serializedName: 'vendor',
            type: {
              name: 'String'
            }
          },
          deviceFamily: {
            required: false,
            serializedName: 'deviceFamily',
            type: {
              name: 'String'
            }
          },
          firmwareVersion: {
            required: false,
            serializedName: 'firmwareVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VpnDeviceScriptParameters;
