/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of the request to list WebApplicationFirewallPolicies. It contains a
 * list of WebApplicationFirewallPolicy objects and a URL link to get the the
 * next set of results.
 */
class WebApplicationFirewallPolicyListResult extends Array {
  /**
   * Create a WebApplicationFirewallPolicyListResult.
   * @property {string} [nextLink] URL to get the next set of
   * WebApplicationFirewallPolicy objects if there are any.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WebApplicationFirewallPolicyListResult
   *
   * @returns {object} metadata of WebApplicationFirewallPolicyListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebApplicationFirewallPolicyListResult',
      type: {
        name: 'Composite',
        className: 'WebApplicationFirewallPolicyListResult',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'WebApplicationFirewallPolicyElementType',
                  type: {
                    name: 'Composite',
                    className: 'WebApplicationFirewallPolicy'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebApplicationFirewallPolicyListResult;
